=== share/hedgewars/Data/Fonts/CMakeLists.txt ===
install(FILES
    DejaVuSans-Bold.ttf
    wqy-zenhei.ttc
    DESTINATION ${SHAREPATH}Data/Fonts)
