=== debian/changelog ===
hedgewars (0.9.20.5-2) unstable; urgency=medium

  * Fixed many copyright issues

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sun, 12 Jan 2014 15:35:36 +0100

hedgewars (0.9.20.5-1) unstable; urgency=low

  * New upstream tarball, upload to unstable
  * Simplified debian/rules, by removing override_dh_install
  * debian/control, reorganized and dropped some useless build-deps
    taken from upstream wiki build page

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sat, 04 Jan 2014 17:53:27 +0100

hedgewars (0.9.20.3-2) experimental; urgency=low

  * Removed fPIC support on fpc, fixing build failures
    in arm* and sparc platforms

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 03 Jan 2014 01:32:36 +0100

hedgewars (0.9.20.3-1) unstable; urgency=low

  * New upstream minor release, suitable for unstable

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 02 Jan 2014 12:37:23 +0100

hedgewars (0.9.20-2) experimental; urgency=low

  * Building without parallel support

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sun, 29 Dec 2013 14:02:19 +0100

hedgewars (0.9.20-1) experimental; urgency=low

  * New upstream release (lp: #1264606)
    - new Mission Campaign: A Space Adventure!
      (thanks to Master_ex for working on it!)
    - Shapes on drawn maps
    - New rubber utility
    - A polished Graphical user interface
    - AFK mode. (Press p when not your turn online
      to trigger autoskip of your turn.)
    - Visual enhancements for whip and crosshair
    - New hats
    - New voice pack (Russian)
    - Map edges can wrap or bounce.
    - Password protected rooms
    - Translation updates
    - Many, many, many bugfixes.
    - And much more (see ChangeLog.txt)
  * Switch to debhelper

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sat, 28 Dec 2013 09:10:41 +0100

hedgewars (0.9.19.3-2) experimental; urgency=low

  * Upload to experimental
  * debian/rules
    - no linking of libgcc_s.so.1 is needed anymore
    - simplified some target
  * debian/control
    - Bumped standard version to 3.9.5, no changes required.
    - moved libpng12-dev to libpng-dev.
    - VCS-Git and VCS-Browser are now in a canonical form
    - extended hedgewars-data description
  * debian/copyright
    - fixed copyright symbol usage

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 27 Jun 2013 15:59:59 +0200
