=== debian/watch ===
version=3
http://hedgewars.org/download.html .*/hedgewars-src-(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
